//+------------------------------------------------------------------+
//|                                                     cci bars.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red

#property indicator_color3 Navy
#property indicator_color4 Maroon

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3

//---- input parameters
extern int PeriodCCI = 7;

extern int CCI_OB = 150;
extern int CCI_OS = -150;

extern int TF = 0;

//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double MUpBuffer[];
double MDnBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,MUpBuffer);
   SetIndexBuffer(3,MDnBuffer);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="CCI Bars("+PeriodCCI+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,PeriodCCI);
   SetIndexDrawBegin(1,PeriodCCI);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), limit, shift;
  
   
   if(counted_bars<0) return(-1);
   limit=Bars-counted_bars;
    
   double CCI;
   
 for(shift=limit;shift>=0;shift--)
  {   	

      CCI=iCCI(NULL,TF,PeriodCCI,5,shift);

   	
      if ((CCI > 0) && (CCI > CCI_OB)) {
       MUpBuffer[shift]=1.0;
	    MDnBuffer[shift]=0; 
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
      else if (CCI > 0) {
	    UpBuffer[shift]=1.0;
	    DnBuffer[shift]=0; 
	    MUpBuffer[shift]=0;
	    MDnBuffer[shift]=0; 
	    }
	   else  if ((CCI < 0) && (CCI < CCI_OS)) {
	    MDnBuffer[shift]=1.0; 
	    MUpBuffer[shift]=0;
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
	   else if (CCI < 0) 
	    {
	     DnBuffer[shift]=1.0;
	     UpBuffer[shift]=0; 
	     MUpBuffer[shift]=0;
	     MDnBuffer[shift]=0; 
	    }
	 
	}
	return(0);	
 }

